/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
		Copyright (C) 2014-2020 by Frédéric Coste

		This program is free software: you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation, either version 3 of the License, or
		(at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <vcl.h>
#pragma hdrstop
#include "TCheatActionWinKeyDown.h"
#if (__BORLANDC__ == 0x551) // Borland C++ Builder 5 Update 1
#include "..\Forms\TFormMain.h"
#else /* __BORLANDC__ */
#include "..\Forms_XE3\TFormMain.h"
#endif /* __BORLANDC__ */

//---------------------------------------------------------------------------

#pragma package(smart_init)


__fastcall TCheatActionWinKeyDown::TCheatActionWinKeyDown(AnsiString Command) : TCheatAction()
//
// Constructor
//
{
  int ParamPos = Command.Pos("=");
  int ParamLength = Command.Length() - ParamPos;
  int CommentPos = Command.Pos(";");

  if (CommentPos)
  {
    ParamLength = CommentPos - ParamPos - 1;
  }
  else
  {
    CommentPos = Command.Length();
  }

  if (ParamPos < CommentPos)
  {
    AnsiString Param = Command.SubString(ParamPos+1, ParamLength).Trim();
    int SeparatorPos = Param.Pos(",");

		// Key
		AnsiString StringKey = Param.SubString(1, SeparatorPos-1).Trim();

		// Shift
		Param = Param.SubString(SeparatorPos+1, Param.Length()).Trim();
		SeparatorPos = Param.Pos(",");
		AnsiString StringShift = Param.SubString(SeparatorPos+1, Param.Length()).Trim();

		try
		{
			if ( (StringKey.Pos("0x") == 1) || (StringKey.Pos("0X") == 1) )
      {
				mKey = StrToInt(StringKey.Trim());
      }
      else
      {
				mKey = StringKey.ToInt();
      }
		}
		catch(...)
		{
			mKey = 0;
		}

		mShift = TShiftState();

		try
		{
			int ShiftState = StringShift.ToInt();
			if (ShiftState & 1) mShift = mShift << ssShift;
			if (ShiftState & 2) mShift = mShift << ssCtrl;
			if (ShiftState & 4) mShift = mShift << ssAlt;
		}
		catch(...)
		{
		}

		if (mKey > 0)
		{
			mValid = true;
		}
	}
}
//---------------------------------------------------------------------------


__fastcall TCheatActionWinKeyDown::~TCheatActionWinKeyDown(void)
//
// Destructor
//
{
}
//---------------------------------------------------------------------------


void __fastcall TCheatActionWinKeyDown::Execute(tNativeCPC* NativeCPC)
{
	WORD Key = mKey;
	FormMain->OnWINInputKeyDown(Key,mShift);

	NOT_USED(NativeCPC);
}
//---------------------------------------------------------------------------


